"""
DIREITOS RESERVADOS / RIGHTS RESERVED / DERECHOS RESERVADOS

https://pdf.ai/

Esse robô envia o PDF para o site https://pdf.ai/
    e recupera um arquivo txt com a resposta do GPT
"""
class ErroPDFAIException(Exception):
    pass

from FuncsForSPO.fgpt.pdfanalyser.base import *

class GPTPDF(Bot):    
    def __init__(self, file_pdf: str, credentials:tuple, prompt:str, headless: bool=True) -> str:
        self.PDF_PATH = os.path.abspath(file_pdf)
        self.PROMPT = prompt
        self.HEADLESS = headless
        self.CREDENTIALS = credentials
        super().__init__(self.HEADLESS)
    
    def run(self):
        try:
            self.DRIVER.get('https://pdf.ai/auth/sign-in')
            espera_elemento_disponivel_e_clica(self.WDW, (By.CSS_SELECTOR, 'img[alt="Github logo"]~span'))
            espera_input_limpa_e_envia_send_keys(self.WDW, self.CREDENTIALS[0], (By.CSS_SELECTOR, '#login_field'))
            espera_input_limpa_e_envia_send_keys(self.WDW, self.CREDENTIALS[1]+'\n', (By.CSS_SELECTOR, '#password'))
            
            try:
                espera_elemento_disponivel_e_clica(self.WDW, (By.CSS_SELECTOR, 'button[data-octo-click="oauth_application_authorization"]'))
            except (NoSuchElementException, TimeoutException):
                pass
            
            espera_elemento_disponivel_e_clica(self.WDW10, (By.CSS_SELECTOR, 'button:last-of-type span'))

            espera_elemento(self.WDW, (By.CSS_SELECTOR, 'input[type="file"]'), in_dom=True)
            self.DRIVER.find_element(By.CSS_SELECTOR, 'input[type="file"]').send_keys(self.PDF_PATH)
            espera_elemento_disponivel_e_clica(self.WDW, (By.CSS_SELECTOR, 'div[class*="flex justify-between"]>button'))
            espera_input_limpa_e_envia_send_keys(self.WDW30, 'Coloque no inicio da sua resposta: "IA" e me responda em português. '+self.PROMPT, (By.CSS_SELECTOR, 'textarea[placeholder*="Send"]'))
            espera_elemento_disponivel_e_clica(self.WDW30, (By.CSS_SELECTOR, 'textarea[placeholder*="Send"]~button'))

            while True:
                text = espera_e_retorna_elemento_text(self.WDW, (By.CSS_SELECTOR, '#__next main>div~div>div~div>div>div>div>div~div'))
                if 'IA' in text:
                    break
                else:
                    continue
            self.DRIVER.get('https://pdf.ai/documents')
            elements = espera_e_retorna_lista_de_elementos(self.WDW, (By.CSS_SELECTOR, 'tbody>tr>td:last-child>button'))
            espera_elemento_disponivel_e_clica(self.WDW, (By.CSS_SELECTOR, 'tbody>tr>td:last-child>button'))
            espera_elemento_disponivel_e_clica(self.WDW, (By.CSS_SELECTOR, 'h3~div>button'))
            sleep(.5)
            espera_elemento_disponivel_e_clica(self.WDW, (By.CSS_SELECTOR, 'a[href="/auth/account"]~button'))
            self.DRIVER.quit()
            return text
        except Exception as e:
            faz_log(repr(e), 'c*')
            self.DRIVER.quit()
            raise ErroPDFAIException
